Index: pbx.c
===================================================================
RCS file: /usr/cvsroot/asterisk/pbx.c,v
retrieving revision 1.171
diff -u -r1.171 pbx.c
--- pbx.c	16 Nov 2004 03:13:05 -0000	1.171
+++ pbx.c	19 Nov 2004 00:50:17 -0000
@@ -4941,7 +4941,7 @@
 	char *s;
 	char *exten, *pri, *context;
 	char *stringp=NULL;
-	int ipri;
+	int ipri=0, cpri=0;
 
 	if (!data || ast_strlen_zero(data)) {
 		ast_log(LOG_WARNING, "Goto requires an argument (optional context|optional extension|priority)\n");
@@ -4953,7 +4953,16 @@
 	exten = strsep(&stringp, "|");
 	if (!exten) {
 		/* Only a priority in this one */
-		pri = context;
+		if(*context == '+') {
+			context++;
+			cpri = chan->priority + atoi(context);
+			pri = NULL;
+		} else if(*context == '-') {
+			context++;
+			cpri = chan->priority - atoi(context);
+			pri = NULL;
+		} else 
+			pri = context;
 		exten = NULL;
 		context = NULL;
 	} else {
@@ -4965,7 +4974,7 @@
 			context = NULL;
 		}
 	}
-	if (sscanf(pri, "%i", &ipri) != 1) {
+	if (pri && sscanf(pri, "%i", &ipri) != 1) {
 		if ((ipri = ast_findlabel_extension(chan, context ? context : chan->context, (exten && strcasecmp(exten, "BYEXTENSION")) ? exten : chan->exten, 
 			pri, chan->cid.cid_num)) < 1) {
 			ast_log(LOG_WARNING, "Priority '%s' must be a number > 0, or valid label\n", pri);
@@ -4973,7 +4982,7 @@
 		}
 	} 
 	/* At this point we have a priority and maybe an extension and a context */
-	chan->priority = ipri - 1;
+	chan->priority = (cpri ? cpri - 1: ipri -1);
 	if (exten && strcasecmp(exten, "BYEXTENSION"))
 		strncpy(chan->exten, exten, sizeof(chan->exten)-1);
 	if (context)
